#include "colors.inc"
#include "textures.inc"                   
#include "stones.inc"

// Pre-Define Some Textures Used in the Picture
#declare Ground= pigment { // Sand to Dirt
        gradient y
        scale 75
        color_map {
            [ 0 Tan ]
            [ .3 VeryDarkBrown ]
            [ 1 ForestGreen ]
        }
    }
#declare Ground2= pigment { // Sand to Dirt
        gradient y
        scale 75
        color_map {
            [ 0 Tan transmit 1 ]
            [ .4 ForestGreen ]
            [ 1 ForestGreen ]
        }
    }    
    
#declare Bricks = pigment {
    image_map { gif "bg0216.gif" }
    scale 60
}

#declare Roof = pigment {
    image_map { gif "bg0408.gif" }
    scale 20
}

#declare random = seed(831);

#declare camera_location = < 170, 125, -1050> ;
#declare camera_look_at = < 0, 200, 0> ;
#declare effect_location = < rand(random)*400+200, rand(random)*100+450, 100> ;
#declare effect_type = "Star"
#declare effect_colour = <1,0,0>;
#declare effect_scale = .1; 

#include "Lens.inc"

#declare effect_location = < rand(random)*400+200, rand(random)*100+450, 100> ;
#declare effect_type = "Star"
#declare effect_colour = <1,.5,0>;
#declare effect_scale = .1; 

#include "Lens.inc"

#declare effect_location = < rand(random)*400+200, rand(random)*100+450, 100> ;
#declare effect_type = "Star"
#declare effect_colour = <1,1,0>;
#declare effect_scale = .1; 

#include "Lens.inc"

#declare effect_location = < rand(random)*400+200, rand(random)*100+450, 100> ;
#declare effect_type = "Star"
#declare effect_colour = <0,1,0>;
#declare effect_scale = .1; 

#include "Lens.inc"

#declare effect_location = < rand(random)*400+200, rand(random)*100+450, 100> ;
#declare effect_type = "Star"
#declare effect_colour = <0,0,1>;
#declare effect_scale = .1; 

#include "Lens.inc"

#declare effect_location = < rand(random)*400+200, rand(random)*100+450, 100> ;
#declare effect_type = "Star"
#declare effect_colour = <0,1,1>;
#declare effect_scale = .1; 

#include "Lens.inc"

#declare effect_location = < rand(random)*400+200, rand(random)*100+450, 100> ;
#declare effect_type = "Star"
#declare effect_colour = <.3,.18,.31>;
#declare effect_scale = .1;

#include "Lens.inc"



//camera {
//	location <170, 125, -1050>
//	look_at <0, 200, 0>
    //location < 0,550,-500>
    //look_at <0,500,0>
    //location <155,425,-250>
    //look_at <145,423,-60>
    //location < 0,465,-157>
    //look_at <0,200,-1000>

//}


//**** CREATE THE SKY ****

light_source { 
    <850,5000,-5250> 
    color White
    area_light <1000, 0, 0>, <0, 0, 1000>, 5, 5
    adaptive 1
    jitter
} // Moonlight
  
fog {  // The Sky 
    distance 2500
    color Black
    fog_type 2
    fog_offset 250 
    fog_alt 150
    turbulence 1
  }

box { // Clouds Layer 1
    <-10000,1000,-5000>
    <10000,1025,15000>
    pigment {
      bozo
      turbulence 0.65
      octaves 6
      omega 0.7
      lambda 2
      scale 2000
      color_map {
          [0.0 color rgb <0.85, 0.85, 0.85>]
          [0.25 color rgb <0.75, 0.75, 0.75>]
          [0.5 color rgbt <1, 1, 1, 1>]
          [1.0 color rgbt <1, 1, 1, 1>]

      }
    }
    finish { ambient .2 } 
    no_shadow
} 
/*
box { // Clouds Layer 2
    <-10000,3000,-5000>
    <10000,3025,15000>
    pigment {
      bozo
      turbulence 0.65
      octaves 6
      omega 0.7
      lambda 2
      scale 2000
      rotate y*180
      color_map {
          [0.0 0.1 color rgb <0.85, 0.85, 0.85>
                   color rgb <0.75, 0.75, 0.75>]
          [0.2 0.6 color rgb <0.75, 0.75, 0.75>
                   color rgbt <1, 1, 1, 1>]
          [0.8 1.0 color rgbt <1, 1, 1, 1>
                   color rgbt <1, 1, 1, 1>]
      }
    }
    finish { ambient .2 } 
    no_shadow
} 
*/  

// Stars
sky_sphere { 
  pigment {
    granite  
    color_map {
      [0.79 rgb 0.00 ] // No Stars in this area
      [0.81 rgb 0.20 ] // Very Very Faint Stars
      [0.83 rgb 0.40 ] // Very Very Faint Stars
      [0.85 rgb 0.60 ] // Very Faint Stars
      [0.87 rgb 0.80 ] // Faint Stars
      [0.89 rgb 0.95 ] // Medium White Stars
      [0.91 rgb 1.00 ] // White Stars 
      [0.91 rgb 0.00 ] // No Stars in this area
    }
  scale .015
  }
}    


//**** CREATE THE GROUND  
  
plane { // The Ocean
    y,0
    normal { crackle .1 }
    pigment { Navy }
    finish { reflection 1 }
}   
    
height_field { // The Main Land
    tga "hfgen1.tga"
    smooth
    pigment { White }
    scale <2000, 250, 2000>
    translate <-1000,-75,-2500>
    pigment { Ground }
    //normal {
    //    bump_map { gif "bg0626.gif" }
    //    rotate x*-90
    //    scale 50
    //} 
    finish { crand .3 }
}

//***** CREATE THE FLOATING CASTLE

height_field {
    tga "hfgen.tga"
    smooth
    water_level 0.1
    pigment { Tan }
    scale <600, -500, 600>
    translate <-300,440,-300>
}


    
// The Buildings

difference {
    union { // Bldg 1
        cylinder { 
            <0,0,0>,<0,20,0>,80 
            pigment { Bricks }
        }
        cone {
            <0,20,0>,85
            <0,40,0>,0
            pigment { Roof }
        }
        
    }    
    union { //Bldg 1 Windows
        box { <-81,10,-1>,<81,15,1> }
        box { <-81,10,-1>,<81,15,1> rotate 45 }
        box {<-81,10,-1>,<81,15,1> rotate 90 }
        box {<-81,10,-1>,<81,15,1> rotate 135 }
    }
    translate <-10,400,40>
}    


difference {
    union {   // Bldg 2
        cylinder {
            <0,0,0>,<0,40,0>,60
            open
            pigment { Bricks }
            
        }
        cone {
            <0,40,0>,65
            <0,65,0>,0
            pigment { Roof }
        }
    }
    union { //Bldg 2 Windows
        box { <-61,23,-1>,<61,30,1> }
        box { <-61,23,-1>,<61,30,1> rotate y*30 }
        box { <-61,23,-1>,<61,30,1> rotate y*60 }
        box {<-61,23,-1>,<61,30,1> rotate y*90 }
        box {<-61,23,-1>,<61,30,1> rotate y*120 }
        box {<-61,23,-1>,<61,30,1> rotate y*150 }
        pigment { rgbt 1 }
    }
    translate <70,400,-60>
}   


difference {
    union {   // Bldg3
        cylinder {
            <0,0,0>,<0,60,0>,20
            pigment { Bricks }
        }
        cone {
            <0,60,0>,25
            <0,90,0>,0
            pigment { Roof }
        }
    }
    union { //Bldg 3 Windows
        box { <-21,43,-1>,<21,50,1> }
        box { <-21,43,-1>,<21,50,1> rotate y*45 }
        box {<-21,43,-1>,<21,50,1> rotate y*90 }
        box {<-21,43,-1>,<21,50,1> rotate y*135 }
    }
    
    
    translate <-90,400,-50>
}   

difference {
    union {   // Bldg4
        cylinder {
            <0,0,0>,<0,80,0>,30
            pigment { Bricks }
        }
        cone {
            <0,80,0>,35
            <0,120,0>,0
            pigment { Roof }
        }
    }    
    union { //Bldg 4 Windows
        box { <-31,63,-1>,<31,70,1> }
        box { <-31,63,-1>,<31,70,1> rotate y*30 }
        box { <-31,63,-1>,<31,70,1> rotate y*60 }
        box {<-31,63,-1>,<31,70,1> rotate y*90 }
        box {<-31,63,-1>,<31,70,1> rotate y*120 }
        box {<-31,63,-1>,<31,70,1> rotate y*150 }
    }
    translate <0,400,-130>
}   

difference {
    union {   // Bldg5
        cylinder {
            <0,0,0>
            <0,100,0>,25
            pigment { Bricks }
        }
        cone {
            <0,100,0>,30
            <0,150,0>,0
            pigment { Roof }
        }
    }
    union { //Bldg 5 Windows
        box { <-26,83,-1>,<26,90,1> }
        box { <-26,83,-1>,<26,90,1> rotate y*45 }
        box {<-26,83,-1>,<26,90,1> rotate y*90 }
        box {<-26,83,-1>,<26,90,1> rotate y*135 }
    }
    translate <-110,400,70>
}   

difference {
    union {   // Bldg6
        cylinder {
            <0,0,0>
            <0,120,0>,35
            pigment { Bricks }
        }
        cone {
            <0,120,0>,40
            <0,180,0>,0
            pigment { Roof }
        }
    }
    union { //Bldg 4 Windows
        box { <-36,103,-1>,<36,110,1> }
        box { <-36,103,-1>,<36,110,1> rotate y*30 }
        box { <-36,103,-1>,<36,110,1> rotate y*60 }
        box {<-36,103,-1>,<36,110,1> rotate y*90 }
        box {<-36,103,-1>,<36,110,1> rotate y*120 }
        box {<-36,103,-1>,<36,110,1> rotate y*150 }
    }
    translate <110,400,50>
}   

difference {
    box {
        <-20,0,-20>
        <20,120,20>
    
    } 
    union {
        box { <-14,114,-21>,<-6,121,21> }
        box { <14,114,-21>,<6,121,21> }
        box { <-21,114,-14>,<21,121,-6> }
        box { <-21,114,14>,<21,121,6> }
        box { <-11.5,62,-21>,<-8.5,70,21> }
        box { <11.5,92,-21>,<8.5,100,21> }
        box { <11.5,32,-21>,<8.5,40,21> }
        box { <-21,62,-11.5>,<21,70,-8.5> }
        box { <-21,92,11.5>,<21,100,8.5> }
        box { <-21,32,11.5>,<21,40,8.5> }        
    }
    translate <-50,400,-90>
    pigment { Bricks }
}

//**** ADD THE TREES

        #declare TREE_RAND = seed(0);
        #declare Wiggle_Flag = on;
        #declare Branches_On_End_Flag = on;

        #declare Number_Of_Large_Branches = 2;
        #declare Number_Of_Medium_Branches = 4;
        #declare Number_Of_Small_Branches = 8;

        #declare Large_Branch_Minimum_Angle = 0;
        #declare Large_Branch_Maximum_Angle = 75;

        #declare Medium_Branch_Minimum_Angle = 0;
        #declare Medium_Branch_Maximum_Angle = 90;
        
        #declare Small_Branch_Minimum_Angle = 0;
        #declare Small_Branch_Maximum_Angle = 90;

        #declare Tree_Trunk_Size = 20;

        #declare Large_Branch_Size_Min = 8;
        #declare Large_Branch_Size_Max = 16;

        #declare Medium_Branch_Size_Min = 4;
        #declare Medium_Branch_Size_Max = 6;

        #declare Small_Branch_Size_Min = 4;
        #declare Small_Branch_Size_Max = 8;

        #declare Leaf_Type = 4;

        #declare TREE_MESH_SIZE = 200;

        #declare Leaf_Texture = texture { T_Stone18 scale 0.5 }
        #declare Bark_Texture = texture { T_Stone14
                normal { bumps 2.0 scale 0.1 } }



// Now go and build the tree, then show it.

        #declare numtrees=1;
        #declare random = seed(2);
        #declare random2 = seed(3);
        
        #declare Number_Of_Large_Branches = rand(random)*2+2;
        #declare Number_Of_Medium_Branches = Number_Of_Large_Branches*2;
        #declare Number_Of_Small_Branches = Number_Of_Large_Branches*4;
        #include "ptd_tree.inc"
        object { 
            Complete_Tree 
            translate <100,35,-800>
        }
        #declare Number_Of_Large_Branches = rand(random)*2+2;
        #declare Number_Of_Medium_Branches = Number_Of_Large_Branches*2;
        #declare Number_Of_Small_Branches = Number_Of_Large_Branches*4;
        #include "ptd_tree.inc"
        object { 
            Complete_Tree 
            translate <50,30,-900>
        }
        #declare Number_Of_Large_Branches = rand(random)*2+2;
        #declare Number_Of_Medium_Branches = Number_Of_Large_Branches*2;
        #declare Number_Of_Small_Branches = Number_Of_Large_Branches*4;
        #include "ptd_tree.inc"
        object { 
            Complete_Tree 
            translate <170,60,-950>
        }        
        #declare Number_Of_Large_Branches = rand(random)*2+2;
        #declare Number_Of_Medium_Branches = Number_Of_Large_Branches*2;
        #declare Number_Of_Small_Branches = Number_Of_Large_Branches*4;
        #include "ptd_tree.inc"
        object { 
            Complete_Tree 
            translate <180,50,-850>
        }        
        #declare Number_Of_Large_Branches = rand(random)*2+2;
        #declare Number_Of_Medium_Branches = Number_Of_Large_Branches*2;
        #declare Number_Of_Small_Branches = Number_Of_Large_Branches*4;
        #include "ptd_tree.inc"
        object { 
            Complete_Tree 
            translate <-50,30,-750>
        }        

    #declare DoorWay = union {
    #declare OuterRadiusX = 15 ;                          
    #declare OuterRadiusY = 15 ;                           
    #declare InnerRadiusX = 13 ;                          
    #declare InnerRadiusY = 13 ;                           
    #declare Segments = 5 ;                                
    #declare Start = -0.5 * pi;
    #declare AbsoluteEnd = 0.5 * pi ;                       
    #declare TubeRadius = 2 ;                             
    #declare Width = 1 ;                                    
    #include "arch.inc"                                     
    cylinder { 
        <-14,0,0>
        <-14,-25,0>,3
    }
    cylinder { 
        <14,0,0>
        <14,-25,0>,3
    }
    texture { T_Grnt25 }                                   
    
}                                                       

object { DoorWay translate <0,55,-760> }                                                             
object { DoorWay translate <0,400,-200> }                                                             

